//+------------------------------------------------------------------+
//|                                                  Alicia v1_3.mq4 |
//|                                          Copyright  2008 giapel |
//|                                                www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 giapel"
#property link      "www.forex-tsd.com"

extern double  Start_Lot_Size=0.2;//starting lot size for cycle
extern int     Max_Trades=5000;//maximum number of trades allowed
extern double  Close_By_Profit=300;//close if >= to this $ amount
extern int     Timeframe=4;//timeframe used for MA calculation, 1=1m, 2=5m, 3=15m, 4=30m, 5=1h, 6=4h, 7=1d
extern int     Slippage=5;
extern int     Magic_Number=9009;

double Lot_Size,ClosedProfit;
int MA_Timeframe;

double Keltner_Low;
double Keltner_High;
double Keltner_High_prec;
double Keltner_Low_prec;
double Macd,Macd_Signal,Macd_prev,Macd_Signal_prev;
string MarketCondition = "";


double ClosedPartial = 0.0;

extern double Step = 3;
extern double Space = 12;
int GridOrder = 4;

int Ticket,LastTicket;
double LastBuy,LastSell;
int LastTicketBuy,LastTicketSell;
double CycleOpen;

int Error=0;
int i=0;
int NumPosToClose = 0;
double temp,temp1;
double temp_double;

#include <Alicia_Include_v17.mqh>
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
if (Timeframe==1){MA_Timeframe=1;}
if (Timeframe==2){MA_Timeframe=5;}
if (Timeframe==3){MA_Timeframe=15;}
if (Timeframe==4){MA_Timeframe=30;}
if (Timeframe==5){MA_Timeframe=60;}
if (Timeframe==6){MA_Timeframe=240;}
if (Timeframe==7){MA_Timeframe=1440;}

if (!GlobalVariableCheck("ALC_CycleOpen"))
 GlobalVariableSet("ALC_CycleOpen",0);
else CycleOpen = GlobalVariableGet("ALC_CycleOpen");

if (!GlobalVariableCheck("ALC_CycleOpen"))
 GlobalVariableSet("ALC_CycleOpen",0);
else CycleOpen = GlobalVariableGet("ALC_CycleOpen"); 
 
if (!GlobalVariableCheck("ALC_LastBuy"))
 GlobalVariableSet("ALC_LastBuy",0);
else LastBuy = GlobalVariableGet("ALC_LastBuy");

if (!GlobalVariableCheck("ALC_LastSell"))
 GlobalVariableSet("ALC_LastSell",0);
else LastSell = GlobalVariableGet("ALC_LastSell"); 
 
if (!GlobalVariableCheck("ALC_LastTicketBuy"))
 GlobalVariableSet("ALC_LastTicketBuy",0);
else LastTicketBuy = GlobalVariableGet("ALC_LastTicketBuy");

if (!GlobalVariableCheck("ALC_LastTicketSell"))
 GlobalVariableSet("ALC_LastTicketSell",0);
else LastTicketSell = GlobalVariableGet("ALC_LastTicketSell");

if (!GlobalVariableCheck("ALC_ClosedProfit"))
 GlobalVariableSet("ALC_ClosedProfit",0);
else ClosedProfit = GlobalVariableGet("ALC_ClosedProfit");

if (!GlobalVariableCheck("ALC_ClosedPartial"))
 GlobalVariableSet("ALC_ClosedPartial",0);
else ClosedPartial = GlobalVariableGet("ALC_ClosedPartial");
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

Comment("\n                             OpenOrders = ",MyOrdersTotal(Magic_Number)," (Max = ",Max_Trades,
        ")\n                           Open Profit = ",MyAccountProfit(Magic_Number),
        "\n                             Closed Profit = ",ClosedProfit,
        "\n                             Step = ",Step,
        "\n\n                          LastTicketSell =  ",LastTicketSell,
        "\n                             LastTicketBuy =  ",LastTicketBuy,
        "\n\n                          LastBuy =  ",LastBuy,
        "\n                             NumPositionClosed =  ",NumPosToClose,
        "\n\n                          MyOrdersTotalSell(Magic_Number) = ",MyOrdersTotalSell(Magic_Number),
        "\n                             MyOrdersTotalBuy(Magic_Number) = ",MyOrdersTotalBuy(Magic_Number),
        "\n\n                          ClosedPartial = ",ClosedPartial,
        "\n\n\n                      CycleOpen = ",CycleOpen,
        "\n                             CycleOpen =",CycleOpen,
        "\n\n\n                         MathAbs((CycleOpen-Ask)>100*Point)   ",MathAbs((CycleOpen-Ask)*10000),
        "\n                          MathAbs((CycleOpen-Bid)>100*Point)   ",MathAbs((CycleOpen-Bid)*10000)      
);
        

 if (MyAccountProfit(Magic_Number)+ClosedPartial >= Close_By_Profit)
  {
    CloseProfit(Magic_Number);
    ClosedPartial = 0.0;
    ClosedProfit = 0.0;
    GlobalVariableSet("ALC_ClosedProfit",ClosedProfit);
    GlobalVariableSet("ALC_ClosedPartial",ClosedPartial);
  }

 
// pyramiding based on keltner channel

Keltner_High      = iCustom(NULL,MA_Timeframe,"KeltnerChannel",0,1);
Keltner_Low       = iCustom(NULL,MA_Timeframe,"KeltnerChannel",1,1);
Keltner_High_prec = iCustom(NULL,MA_Timeframe,"KeltnerChannel",0,2);
Keltner_Low_prec  = iCustom(NULL,MA_Timeframe,"KeltnerChannel",1,2);
Macd              = iMACD(NULL,PERIOD_M30,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
Macd_Signal       = iMACD(NULL,PERIOD_M30,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
Macd_prev              = iMACD(NULL,PERIOD_M30,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
Macd_Signal_prev       = iMACD(NULL,PERIOD_M30,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);

//Rsi               = iRSI(NULL,PERIOD_D1,14,PRICE_CLOSE,1);
if(Macd>0 && Macd>Macd_Signal) MarketCondition = "StrongBuy";
if(Macd<0 && Macd<Macd_Signal) MarketCondition = "StrongSell";
if(Macd_prev>0 && Macd_prev<Macd_Signal_prev && Macd>Macd_Signal) MarketCondition = "RetraceToSell";
if(Macd_prev<0 && Macd_prev>Macd_Signal_prev && Macd<Macd_Signal) MarketCondition = "RetraceToBuy";

//   additional orders
if ((MyOrdersTotal(Magic_Number)>0) && (MyOrdersTotal(Magic_Number)<Max_Trades))
{
  if(MyOrdersTotalBuy(Magic_Number)<1) {
     LastTicketBuy=LastTicketSell;
     LastBuy=LastSell;
  }
 
  if (/*MarketCondition == "StrongSell" ||*/ MarketCondition == "RetraceToSell" ){
     
         
  temp_double = CloseProfitBSOneClose(Magic_Number,0,Lot_Size);

     if(temp_double>0 ){
       ClosedPartial+=temp_double;
       GlobalVariableSet("ALC_ClosedPartial",ClosedPartial);
       temp_double = 0;
     }  
     
     LastBuy = CycleOpen;
     LastSell = CycleOpen;
     GlobalVariableSet("ALC_CycleOpen",CycleOpen);
     GlobalVariableSet("ALC_LastBuy",LastBuy);
     GlobalVariableSet("ALC_LastSell",LastSell);
  }
        if (OpenNewOrder(Magic_Number,0) && Ask >= CycleOpen && MathMod(Ask/Point,Step)==0 )
        {
             Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"ALC_LongAdd",Magic_Number,0,Green);
             
             LastTicketBuy = Ticket;
             GlobalVariableSet("ALC_LastTicketBuy",LastTicketBuy);
             
             if(OrderSelect(LastTicketBuy, SELECT_BY_TICKET)==true)
             LastBuy=OrderOpenPrice();
             GlobalVariableSet("ALC_LastBuy",LastBuy);
        }
}

if ((MyOrdersTotal(Magic_Number)>0) && (MyOrdersTotal(Magic_Number)<Max_Trades))
{
   if(MyOrdersTotalSell(Magic_Number)<1) {
      LastTicketSell=LastTicketBuy;
      LastSell=LastBuy;
   }
  if (/*MarketCondition == "StrongBuy" ||*/ MarketCondition == "RetraceToBuy"){
     
  temp_double = CloseProfitBSOneClose(Magic_Number,1,Lot_Size);
       
     if(temp_double>0 ){
        ClosedPartial+=temp_double;
        GlobalVariableSet("ALC_ClosedPartial",ClosedPartial); 
        temp_double = 0;
     } 
     LastSell = CycleOpen;
     LastBuy  = CycleOpen;
     GlobalVariableSet("ALC_CycleOpen",CycleOpen);
     GlobalVariableSet("ALC_LastSell",LastSell);
     GlobalVariableSet("ALC_LastBuy",LastBuy);
   }
 
      if (OpenNewOrder(Magic_Number,1) && Bid <= CycleOpen && MathMod(Bid/Point,Step)==0)
      {
          Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"ALC_ShortAdd",Magic_Number,0,Red);
          Error=GetLastError();
        
          LastTicketSell = Ticket;
          GlobalVariableSet("ALC_LastTicketSell",LastTicketSell);
        
          if(OrderSelect(LastTicketSell, SELECT_BY_TICKET)==true)
          LastSell=OrderOpenPrice();
          GlobalVariableSet("ALC_LastSell",LastSell);
      }    
}
// new order 
  if ((MyOrdersTotal(Magic_Number)==0) )
  if (Keltner_High <Ask  )
  {
    Lot_Size=Start_Lot_Size;
    Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"ALC_Long",Magic_Number,0,Green);
    LastTicketBuy = Ticket;
    GlobalVariableSet("ALC_LastTicketBuy",LastTicketBuy);
       if(OrderSelect(LastTicketBuy, SELECT_BY_TICKET)==true)
        {
         CycleOpen=OrderOpenPrice();
         LastBuy=OrderOpenPrice();
        }
       GlobalVariableSet("ALC_CycleOpen",CycleOpen);
       GlobalVariableSet("ALC_LastBuy",LastBuy);
    }
if ((MyOrdersTotal(Magic_Number)==0) )
  if (Keltner_Low>Bid  )
   {
     Lot_Size=Start_Lot_Size;
     Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"ALC_Short",Magic_Number,0,Red);
     LastTicketSell = Ticket;
     GlobalVariableSet("ALC_LastTicketSell",LastTicketSell);
     if(OrderSelect(LastTicketSell, SELECT_BY_TICKET)==true)
        {
         CycleOpen=OrderOpenPrice();
         LastSell=OrderOpenPrice();
        }
       GlobalVariableSet("ALC_CycleOpen",CycleOpen);
       GlobalVariableSet("ALC_LastSell",LastSell);
    }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+